Program project1;

{$R *.res}

{$APPTYPE CONSOLE}

Uses
  interfaces,
  SysUtils,
  Classes,
  PdfDoc,
  PdfTypes,
  PdfFonts,
  PdfImages,
  pReport,
  Graphics;

Const

  PageHeight = 297; // in mm
  PageWidth = 210.3; // in mm

  offset_x = 10;
  offset_y = 10;

Var
  FDoc: TPdfDoc;
  PW, PH: integer; // Global for PageWidth, PageHeight in Pixels

Function convert_dimension(vmin, vmax, v: Single; rmin, rmax: Single): Single;
Begin
  If (vmax - vmin = 0) Then Begin // Div by 0 abfangen
    result := rmin;
    exit;
  End
  Else Begin
    result := ((((v - vmin) * (rmax - rmin)) / (vmax - vmin)) + rmin);
  End;
End;

Procedure LoadAndPlaceImage(Filename: String; x, y, w, h: Single);
Var
  bmp: TBitmap;
  img: TPdfImage;
Begin
  bmp := TBitmap.Create;
  bmp.loadfromfile(Filename);
  img := CreatePdfImage(bmp, 'Pdf-Bitmap', FDoc.ObjectMgr);
  FDoc.AddXObject('Img1', img);

  // TODO: Das Bild wird geladen und wohl auch dem PDF hinzugefügt, doch wie plaziere ich es und mache es Sichtbar ?

  bmp.free;
End;

Procedure DrawLine(X1, Y1, X2, Y2: Single);
Var
  mx1, mx2, my1, my2: Single;
Begin
  mx1 := convert_dimension(0, PageWidth, x1 + offset_x, 0, pw);
  mx2 := convert_dimension(0, PageWidth, x2 + offset_x, 0, pw);
  my1 := convert_dimension(0, PageHeight, y1 + offset_y, 0, ph);
  my2 := convert_dimension(0, PageHeight, y2 + offset_y, 0, ph);
  With FDoc.Canvas Do Begin
    MoveTo(mX1, PageHeight - mY1);
    LineTo(mX2, PageHeight - mY2);
    Stroke;
  End;
End;

Procedure Textout(X, Y: Single; Text: String);
Var
  mx, my: Single;
Begin
  mx := convert_dimension(0, PageWidth, x + offset_x, 0, pw);
  my := convert_dimension(0, PageHeight, y + offset_y, 0, ph);
  With FDoc.Canvas Do Begin
    BeginText;
    MoveTextPoint(mx, PageHeight - mY);
    ShowText(Text);
    EndText;
  End;
End;

Var
  fs: tfilestream;

Begin
  FDoc := TPdfDoc.Create;
  fs := TFileStream.Create('sample.pdf', fmCreate Or fmOpenWrite);
  FDoc.NewDoc;
  FDoc.AddPage;
  pw := FDoc.Canvas.PageWidth;
  pH := FDoc.Canvas.PageHeight;

  FDoc.Canvas.SetRGBStrokeColor(clred); // Zeichenfarbe auf Rot ;)

  DrawLine(0, 0, 5, 5);

  FDoc.Canvas.SetFont('Arial', 12);
  Textout(20, 30, 'Hallo Welt');

  FDoc.Canvas.SetRGBFillColor(clgreen); // Schriftfarbe auf Grün ;)
  FDoc.Canvas.SetFont('Arial', 10);
  Textout(20, 50, 'Hallo Welt, klein');

  LoadAndPlaceImage('data' + PathDelim + 'test.bmp', 100, 150, 50, 50);

  FDoc.SaveToStream(fs);
  fs.free;
  writeln('Finished, press Enter to close.');
  readln();
End.

